#ifndef DJGPP
#error This can be compile ONLY with DJGPP (GNU C for DOS)
#endif

#include <stdio.h>
#include <string.h>
#include <fstream.h>
#include <iostream.h>
#include <allegro.h>

#include "vyraz.h"
#include "menu.h"

#define MAX_FCES 10
#define S_NO 0;
#define S_YES 1;

int GetMin(const char *ss,double &min);
int GetMax(const char *ss,double &max);
int IsInDf(const char *ss,double &num);
int IsDefOK(const char*);
int IsCelyVyrazOK(const char* s1,const char* s2);

int FCESCNT= 0;
char fcs[MAX_FCES][1024];
char def[MAX_FCES][256];


double ratio_x= 1;
double ratio_y= 1;
double increment= 1;

int MY_GFX_DRIVER= GFX_AUTODETECT;
int MY_GFX_X= 320;
int MY_GFX_Y= 200;
int hlaska;

struct bod {
 int x,y;
} O;

int skonci= S_NO;

int my_list_proc(int msg, DIALOG *d, int c)
{
 if (msg== MSG_CLICK)
  {
   char nadpis[256];
   strcpy(nadpis,fcs[d->d1]);
   nadpis[12]= '\0';
   strcpy((char*) d[1].dp,nadpis);
   broadcast_dialog_message(MSG_DRAW,0);
  }
 return d_list_proc(msg,d,c);
}

int Napoveda()
{
 char *s= new char[65535];
 *s= '\0';
 FILE *f= fopen("help.txt","rb");
 if (f== NULL)
  {
   alert("Nepodarilo se nacit help.txt !",NULL,NULL,"OK",NULL,0,0);
   return D_CLOSE;
  }
 fread(s,1,65535,f);
 fclose(f);
 HELP_DLG[0].dp= s;
 int poc_r= 0;
 for (int i=0;i<= 65535;i++)
  if (s[i]== '\n') poc_r++;
  else if (s[i]== '\0') break;
 HELP_DLG[0].d1= poc_r;
 do_dialog(HELP_DLG,-1);
 delete[] s;
 return D_CLOSE;
}

char *foobar(int index, int *list_size)
{
 *list_size= FCESCNT;
 return fcs[index];
}

int on_konec()
{
 skonci= S_YES;
 return D_CLOSE;
}

int on_zpet()
{
 skonci= S_NO;
 return D_CLOSE;
}

int on_rozliseni()
{
 int w,h,g;
 skonci= S_NO;
 if (gfx_mode_select(&g,&w,&h))
  {
   if (set_gfx_mode(g,w,h,0,0)>=0)
    {
     MY_GFX_DRIVER= g;
     MY_GFX_X= w;
     MY_GFX_Y= h;
     O.x= SCREEN_W/2;
     O.y= SCREEN_H/2;
     RGB current_palette[256];
     get_palette(current_palette);
     current_palette[255].r= 255;
     current_palette[255].g= 255;
     current_palette[255].b= 255;
     current_palette[15].r= 255;
     current_palette[15].g= 255;
     current_palette[15].b= 255;
     set_palette(current_palette);
    return D_CLOSE;
   } else
   {
    set_gfx_mode(MY_GFX_DRIVER,MY_GFX_X,MY_GFX_Y,0,0);
    alert("Nepodarilo se nastavit rozliseni !",NULL,NULL,"OK",NULL,0,0);
    return D_CLOSE;
   }
  } else return D_CLOSE;
 return D_O_K;
}

void odrez(char*);

int on_kresleni()
{
 sprintf(buffer_inc,"%f",increment);
 odrez(buffer_inc);
 double new_i;
 new_i= increment;
 do
 if (do_dialog(KRESLENI_DLG,-1)== 2)
  {
   new_i= atof(buffer_inc);
   if (new_i<=0 || new_i>100) alert("Hodnota mimo povoleny rozsah !",NULL,NULL,"OK",NULL,0,0);
  } else break;
 while (new_i<=0 || new_i>100);
 increment= new_i;
 skonci= S_NO;
 return D_CLOSE;
}

int on_detail_plus_x()
{
 ratio_x= ratio_x*2;
 skonci= S_NO;
 return D_CLOSE;
}
int on_detail_minus_x()
{
 ratio_x= ratio_x/2;
 skonci= S_NO;
 return D_CLOSE;
}

int on_detail_plus_y()
{
 ratio_y= ratio_y*2;
 skonci= S_NO;
 return D_CLOSE;
}
int on_detail_minus_y()
{
 ratio_y= ratio_y/2;
 skonci= S_NO;
 return D_CLOSE;
}

int on_meritko()
{
 ftoa(ratio_x,buffer_m_x);
 odrez(buffer_m_x);
 ftoa(ratio_y,buffer_m_y);
 odrez(buffer_m_y);
 int znovu= TRUE;
 do {
  if (do_dialog(MERITKO_DLG,-1)== 3)
   {
    double new_x= atof(buffer_m_x);
    double new_y= atof(buffer_m_y);
    if (new_x<=0 || new_y<=0) alert("Hodnota mimo povoleny rozsah !",NULL,NULL,"OK",NULL,0,0);
    else {
      ratio_x= new_x; ratio_y= new_y;
      znovu= FALSE;
     }
   } else znovu= FALSE;
 } while (znovu);
 skonci= S_NO;
 return D_CLOSE;
}


int on_smazat_vse()
{
 if (FCESCNT<1)
  {
   alert("Neni co mazat !",NULL,NULL,"OK",NULL,0,0);
   return D_O_K;
  } else
   if (alert("Budou smazany vsechny fukce !",NULL,NULL,"OK","Zrusit",0,0)!= 1) return D_O_K;
 FCESCNT= 0;
 skonci= S_NO;
 return D_CLOSE;
}

int on_smazat()
{
 if (FCESCNT<1)
  {
   alert("Neni co mazat !",NULL,NULL,"OK",NULL,0,0);
   return D_O_K;
  }
 if (do_dialog(Vyb_fce,-1)== 1)
  {
   int vf= Vyb_fce[4].d1;
   FCESCNT--;
   for (int i= vf;i<FCESCNT;i++)
    {
     strcpy(fcs[i],fcs[i+1]);
     strcpy(def[i],def[i+1]);
    }
  }
 skonci= S_NO;
 return D_CLOSE;
}

int on_editace()
{
 if (FCESCNT<1)
  {
   alert("Neni co editovat !",NULL,NULL,"OK",NULL,0,0);
   return D_O_K;
  }
 if (do_dialog(Vyb_fce,-1)== 1)
  {
   int vf= Vyb_fce[4].d1;
   strcpy(buffer1,fcs[vf]);
   strcpy(buffer2,def[vf]);
   int znovu= TRUE;
   do {
   if (do_dialog(FUNKCE_DLG,-1)== 3)
    {
     if (*buffer1== '\0' || *buffer2== 0)
       alert("Vyplnte prosim udaje !",NULL,NULL,"OK",NULL,0,0);
      else
       if (!IsDefOK(buffer2)) alert("Spatne zadany definicni obor !",NULL,NULL,"OK",NULL,0,0);
       else if (!IsCelyVyrazOK(buffer1,buffer2)) alert("Spatne zadana funkce !",NULL,NULL,"OK",NULL,0,0);
        else {
         strcpy(fcs[vf],buffer1);
         strcpy(def[vf],buffer2);
         znovu= FALSE;
         hlaska= TRUE;
        }
    } else znovu= FALSE;
   } while (znovu);
  }
 skonci= S_NO;
// if (vyraz_ok)
 return D_CLOSE;
}

int IsCelyVyrazOK(const char* s1,const char* s2)
{
 if (!IsDefOK(s2)) return FALSE;
 char s[1024];
 int ok;
 double min;
 GetMin(s2,min);
 strcpy(s,argument(s1,min,ok));
 if (!IsVyrazOK(s)) return FALSE;
 if (!ok) return FALSE;
 GetMax(s2,min);
 strcpy(s,argument(s1,min,ok));
 if (!ok) return FALSE;
 if (!IsVyrazOK(s)) return FALSE;
 return TRUE;
}

int on_nova()
{
 skonci= S_NO;
 if (FCESCNT>= MAX_FCES)
  {
   alert("Nelze pridat dalsi funkci !",NULL,NULL,"OK",NULL,0,0);
   return D_O_K;
  }
 int znovu= TRUE;
 do {
 if (FCESCNT>0) {
  strcpy(buffer1,fcs[FCESCNT-1]);
  strcpy(buffer2,def[FCESCNT-1]);
 }
 if (do_dialog(FUNKCE_DLG,-1)==3)
  {
   if (*buffer1== '\0' || *buffer2== 0)
     alert("Vyplnte prosim udaje !",NULL,NULL,"OK",NULL,0,0);
    else
     if (!IsDefOK(buffer2)) alert("Spatne zadany definicni obor !",NULL,NULL,"OK",NULL,0,0);
     else if (!IsCelyVyrazOK(buffer1,buffer2)) alert("Spatne zadana funkce !",NULL,NULL,"OK",NULL,0,0);
      else {
       strcpy(fcs[FCESCNT],buffer1);
       strcpy(def[FCESCNT],buffer2);
       FCESCNT++;
       znovu= FALSE;
       hlaska= TRUE;
      }
  } else znovu= FALSE;
 } while (znovu);
// if (vyraz_ok)
 return D_CLOSE;
}


void draw(double x1,double y1,double x2,double y2,bod pos,int c)
{
  x1= x1*ratio_x;
  y1= y1*ratio_y;
  x2= x2*ratio_x;
  y2= y2*ratio_y;

  if (O.x-x1>SCREEN_W+pos.x || O.y+y1>SCREEN_H+pos.y || O.x-x1<pos.x || O.y+y1<pos.y) return;
  if (O.x-x2>SCREEN_W+pos.x || O.y+y2>SCREEN_H+pos.y || O.x-x2<pos.x || O.y+y2<pos.y) return;

  line(screen,int(O.x+x1)+pos.x,int(O.y-y1)+pos.y,int(O.x+x2)+pos.x,int(O.y-y2)+pos.y,c+1);
}

void odrez(char* pom)
{
 int i;
 for (i= 0;pom[i];i++)
  if (pom[i]== '.') break;

 pom[i+3]= '\0';
 if (pom[i+2]== '0') pom[i+2]= '\0'; else return;
 if (pom[i+1]== '0') pom[i+1]= '\0';
}

void make_graph(int FCESCNT,char s[MAX_FCES][1024],bod pos)
{
 double i;
 double Min,Max;
 int b;
 double x2,y2;

 text_mode(-1);
 // osy
 for (int j=-pos.x;j<O.x*2-pos.x;j++)
  {
   putpixel(screen,j+pos.x,O.y+pos.y,15);
   if (j%40==0)
    {
     char pom[16];
     ftoa(j/ratio_x-O.x/ratio_x,pom);
     odrez(pom);
     if (pom[strlen(pom)-1]== '.') pom[strlen(pom)-1]= '\0';
     textout(screen,font,pom,j+pos.x,O.y+2+pos.y,15);
    }
  }
 for (int j=-pos.y;j<O.y*2-pos.y;j++)
  {
   putpixel(screen,O.x+pos.x,j+pos.y,15);
   if (j%40==0)
    {
     char pom[16];
     ftoa(O.y/ratio_y-j/ratio_y,pom);
     odrez(pom);
     if (pom[strlen(pom)-1]== '.') pom[strlen(pom)-1]= '\0';
     textout(screen,font,pom,O.x+2+pos.x,j+pos.y,15);
    }
  }

 for (int pi= 0;pi< FCESCNT;pi++)
 {
  b= FALSE;
  if (!GetMin(def[pi],Min)) return;
  if (!GetMax(def[pi],Max)) return;
  for (i= Min;i<=Max;i+= increment)        // spocitame body
   {
    char arg[1024];
    double y;
    int ok;
    strcpy(arg,argument(s[pi],i,ok));
    int rv= IsInDf(def[pi],i);
    if (rv== -5) return;
    if (rv) y= evalute(arg,ok);
    else { b= FALSE; continue;}
    if (ok== FALSE && hlaska== TRUE)
     {
      char ps[256];
      ftoa(i,ps);
      if (alert("Nedefinovana hodnota funkce pro x=",ps,NULL,"Pokracovat","Nepsat hlasku",0,0)== 2) hlaska= FALSE;
     }
    if (!b)
     {
      b= TRUE;
      x2= i;
      y2= y;
     }
    draw(i,y,x2,y2,pos,pi);
    x2= i;
    y2= y;
   }
 }
}

int GetNextMinMax(char* s,double &min,double &max)
{
 char pom[256],a;
 if (*s!= '<' && *s!= '(') return FALSE;
 a= *s;
 strcpy(s,&s[1]);
 int i;
 for(i=0;s[i]!= '\0' && s[i]!= ';';i++) pom[i]= s[i];
 if (s[i]== '\0') return FALSE;
 pom[i]= '\0';
 if (!*pom) return FALSE;
 strcpy(s,&s[i]);
 min= atof(pom);
 if (a== '(') min+=increment;
 strcpy(s,&s[1]);
 for(i=0;s[i]!= '\0' && s[i]!= '>' && s[i]!= ')';i++) pom[i]= s[i];
 if (s[i]== '\0') return FALSE;
 pom[i]= '\0';
 if (!*pom) return FALSE;
 max= atof(pom);
 if (s[i]== ')') max-=increment;
 strcpy(s,&s[i+1]);
 return TRUE;
}

int GetMin(const char *ss,double &min)
{
 char s[256];
 double mi,max;
 strcpy(s,ss);
 if (!GetNextMinMax(s,min,max)) return FALSE;
 if (!*s) return TRUE;
 for (;s[0];) { if (!GetNextMinMax(s,mi,max)) return FALSE;
  if (min>mi) min= mi;
 }
}

int GetMax(const char *ss,double &max)
{
 char s[256];
 double mi,min;
 strcpy(s,ss);
 if (!GetNextMinMax(s,min,max)) return FALSE;
 if (!*s) return TRUE;
 for (;s[0];) { if (!GetNextMinMax(s,min,mi)) return FALSE;
  if (max<mi) max= mi;
 }
}

int IsInDf(const char *ss,double &num)
{
 double min,max;
 char s[256];
 strcpy(s,ss);
 for (;s[0];)
  {
   if (!GetNextMinMax(s,min,max)) return -5;
   if (num>=min && num<=max) return TRUE;
  }
 return FALSE;
}

int IsDefOK(const char* ss)
{
 double min,max;
 char s[256];
 strcpy(s,ss);
 for (;s[0];)
  if (!GetNextMinMax(s,min,max)) return FALSE;
 return TRUE;
}

int main()
{
 char p[2];
 int a;
 int get_started= TRUE;
 BITMAP *bmp= create_bitmap(100,30);
 BITMAP *tmp= create_bitmap(100,30);
 bod pos;
 allegro_init();
 install_timer();
 install_keyboard();
 install_mouse();
 ifstream ifstr("fce.ini");
 if (!ifstr.fail() && !ifstr.bad())
  {
   ifstr >> MY_GFX_X >> MY_GFX_Y >> MY_GFX_DRIVER >> increment;
   if (ifstr.fail() || ifstr.bad())
    {
     printf("Chyba v inicializacnim souboru !\nPokracujte libovolnou klavesou.\n");
     readkey();
     MY_GFX_X= 320; MY_GFX_Y= 200;
     MY_GFX_DRIVER= GFX_AUTODETECT; increment= 1;
    }
   ifstr.close();
  }
 set_gfx_mode(MY_GFX_DRIVER,MY_GFX_X,MY_GFX_Y,0,0);

 pos.x= 0; pos.y= 0;
 O.x= SCREEN_W/2;
 O.y= SCREEN_H/2;

 p[0]= -2;
 p[1]= 1;
// Min= 0; Max= 7;

 RGB current_palette[256];
 get_palette(current_palette);
 current_palette[255].r= 255;
 current_palette[255].g= 255;
 current_palette[255].b= 255;
 current_palette[15].r= 255;
 current_palette[15].g= 255;
 current_palette[15].b= 255;
 set_palette(current_palette);
 gui_fg_color= 1;
 gui_bg_color= 15;
// gui_mg_color= 9;

 hlaska= TRUE;
 do {
 show_mouse(NULL);
 clear(screen);
 if (get_started)
  { textout(screen,font,"Stiskem leveho mysiho tlacitka",40,50,1);
    textout(screen,font,"    se dostanete do menu.",40,70,9);
  }
 get_started= FALSE;
 clear_keybuf();
 make_graph(FCESCNT,fcs,pos);
 blit(screen,bmp,0,0,0,0,100,10);
 show_mouse(screen);
 int old_mx= mouse_x;
 int old_my= mouse_y;
 for (;;)
  {
   if (old_mx!= mouse_x && old_my!= mouse_y)
    {
     show_mouse(NULL);
     blit(bmp,tmp,0,0,0,0,100,10);
     char pom[256];
     sprintf(pom,"%i x %i",int(mouse_x/ratio_x-(O.x+pos.x)/ratio_x),int(mouse_y/ratio_y-(O.y+pos.y)/ratio_y));
     textout(tmp,font,pom,0,0,15);
     blit(tmp,screen,0,0,0,0,100,10);
     show_mouse(screen);
     old_mx= mouse_x;
     old_my= mouse_y;
    }
   if (mouse_b & 1)
    {
     if (FCESCNT< 1) continue;
     double _x= mouse_x/ratio_x-O.x/ratio_x;
     char pom[1024];
     int ok;
     strcpy(pom,argument(fcs[FCESCNT-1],_x,ok));
     double _y;
     int rv= IsInDf(def[FCESCNT-1],_x);
//     if (rv== -5) ...
     if (!rv) { alert("Hodnota neni v definicnim oboru funkce !",NULL,NULL,"OK",NULL,0,0);
        continue; }
     else if (rv) _y= evalute(pom,ok);
     ftoa(_y,pom);
     alert(pom,NULL,NULL,"OK",NULL,0,0);
    }
   if (key[KEY_MINUS])
    { skonci= S_NO;
      ratio_x= ratio_x/2;
      break;
    }
   if (key[KEY_EQUALS])
    { skonci= S_NO;
      ratio_x= ratio_x*2;
      break;
    }
   if (key[KEY_MINUS_PAD])
    { skonci= S_NO;
      ratio_y= ratio_y/2;
      break;
    }
   if (key[KEY_PLUS_PAD])
    { skonci= S_NO;
      ratio_y= ratio_y*2;
      break;
    }
   if (key[KEY_LEFT])
    { skonci= S_NO;
      pos.x+= 20;
      break;
    }
   if (key[KEY_RIGHT])
    { skonci= S_NO;
      pos.x-= 20;
      break;
    }
   if (key[KEY_DOWN])
    { skonci= S_NO;
      pos.y-= 20;
      break;
    }
   if (key[KEY_UP])
    { skonci= S_NO;
      pos.y+= 20;
      break;
    }
   if (key[KEY_LEFT])
    { skonci= S_NO;
      pos.x+= 20;
      break;
    }
   if (key[KEY_F10] || key[KEY_ALT] || mouse_b & 2)
    {skonci= S_NO;
     show_mouse(NULL);
     if (do_dialog(MAIN_M,-1)!=-1) break;
      else clear_keybuf();
    }
   if (key[KEY_ESC])
    {
      if (alert("Opravdu skoncit ?",NULL,NULL,"Ano","Ne",0,0)== 1)
       {
        skonci= S_YES;
        break;
       } else { clear(screen); break; }
    }
  }
 } while (!skonci);

 set_gfx_mode(GFX_TEXT,80,25,0,0);
 allegro_exit();

 ofstream ofstr("fce.ini");
 ofstr << MY_GFX_X << " " << MY_GFX_Y << " " << MY_GFX_DRIVER << " " << increment;
 ofstr.flush();
 ofstr.close();
 return 0;
}
